<template>
	<div class="mind-widget" 
		v-loading="loading"
		:style="{gridColumnEnd: `span ${width}`, gridRowEnd: `span ${height}`, backgroundColor: color}"
		@mouseenter="mostrarBtn=true"  @mouseleave="mostrarBtn=false">
		<div class="widget-title"><h1>{{title}}</h1></div>
		<div class="btn-float" v-if="mostrarBtn">
			<el-button v-if="refresh" icon="el-icon-refresh" size="mini"  circle @click="emitRefresh()"></el-button>
		</div>
		<div class="widget-content">
			<slot/>
		</div>
	</div>
</template>
<script>
export default {
	props: {
		width: {
			type: [String, Number],
			default: "1"
		},
		height: {
			type: [String, Number],
			default: "1"
		},
		//posX: {
		//	type: String,
		//},
		//posY: {
		//	type: String,
		//},
		color: {
			type: String,
			default: "",
		},
		title: String,
		requestUri: String,
		dataProperty: String,
		refresh: Boolean,
		refreshInterval: [Number, String],
		loading: Boolean,
	},
	created() {
	},
	mounted() {
		this.emitRefresh()
		if(this.refreshInterval && this.refresh) {
			this.setIntervalData = setInterval( ()=>{ this.emitRefresh()}, this.refreshInterval * 1000)
		}
	},
	beforeDestroy(){
		clearInterval(this.setIntervalData)
	},
	methods: {
		emitRefresh() {
			this.$emit('refresh', new Date().getTime())
		}
	},
	data() {
		return {
			mostrarBtn: false,
			setIntervalData: null
		}
	}
	
}
</script>
<style lang="css" scoped >
.mind-widget {
	position: relative;
	/*background: #20c5d8;*/
	padding: 5px;
	overflow: hidden;
	width: 100%;
	height: 100%;
	display: flex;
	flex-direction: column;
	box-shadow: 0px 0px 5px #00000070;
}

.widget-title {
	flex-grow: 0;
}
.widget-content {
	flex-grow: 1;
	overflow: hidden;
}


h1 {
	margin: 5px 0px;
	font-size: 14px;
}

.btn-float {
	position: absolute;
	right: 10px;
	top: 10px;
}

.btn-float .el-button {
	background-color: #ffffff50;
	border-color: #ffffff50;
}

</style>